package ru.dbotthepony.mc.otm.android.feature;

import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraftforge.common.ForgeMod;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.android.AndroidFeature;
import ru.dbotthepony.mc.otm.android.AndroidFeatureType;
import ru.dbotthepony.mc.otm.capability.android.IAndroidCapability;

import java.util.UUID;

public class AndroidExtendedReach extends AndroidFeature {
	public static final UUID MODIFIER_ID = UUID.fromString("4a3fae46-47a8-a03f-857d-f5c2b2c8f2f2");

	public AndroidExtendedReach(IAndroidCapability capability) {
		super(Registry.AndroidFeatures.EXTENDED_REACH, capability);
	}

	@Override
	public void applyModifiers() {
		var reach = capability.getEntity().getAttribute(ForgeMod.REACH_DISTANCE.get());

		if (reach != null) {
			reach.removePermanentModifier(MODIFIER_ID);
			reach.addPermanentModifier(new AttributeModifier(MODIFIER_ID, type.getDisplayName().toString(), level + 1, AttributeModifier.Operation.ADDITION));
		}
	}

	@Override
	public void removeModifiers() {
		var reach = capability.getEntity().getAttribute(ForgeMod.REACH_DISTANCE.get());

		if (reach != null) {
			reach.removePermanentModifier(MODIFIER_ID);
		}
	}
}
