package ru.dbotthepony.mc.otm.client.screen.panels;

import net.minecraft.client.gui.components.EditBox;
import net.minecraft.network.chat.Component;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class EditBoxPanel extends MinecraftWidgetPanel<EditBox> {
	public EditBoxPanel(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, float width, float height, Component component) {
		super(screen, parent, x, y, width, height, (panel) -> {
			return new EditBox(screen.getFont(), 0, 0, (int) panel.getWidth(), Math.min(20, (int) panel.getHeight()), component) {
				@Override
				public boolean isHoveredOrFocused() {
					return panel.isHovered();
				}
			};
		});
	}

	@Override
	protected void copyValues(EditBox new_widget, EditBox old_widget) {
		new_widget.setValue(old_widget.getValue());
	}

	@Override
	public void tick() {
		super.tick();

		if (widget != null)
			widget.tick();
	}

	@Override
	protected void factorize(EditBox widget, boolean recreation) {
		widget.setFocus(isFocused());
	}

	@Override
	protected void onFocusChanged(boolean new_focused, boolean old_focused) {
		getOrCreateWidget().setFocus(new_focused);
	}

	@Override
	protected boolean mouseClickedInner(double mouse_x, double mouse_y, int flag) {
		if (super.mouseClickedInner(mouse_x, mouse_y, flag)) {
			requestFocus();
			return true;
		}

		return false;
	}
}
