package ru.dbotthepony.mc.otm.menu

import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterScanner
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import net.minecraft.world.SimpleContainer
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.matter.MatterRegistry
import java.math.BigInteger

class MatterScannerMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityMatterScanner? = null
) : PoweredMatteryMenu(
	Registry.Menus.MATTER_SCANNER, p_38852_, inventory, tile
) {
	val input: MatterySlot
	val progress: ProgressGaugeWidget
	val patterns: LevelGaugeWidget

	init {
		val container = if (tile != null) tile.input_slot else SimpleContainer(1)
		input = object : MatterySlot(container, 0, 64, 38) {
			override fun mayPlace(p_40231_: ItemStack): Boolean {
				return MatterRegistry.canDecompose(p_40231_)
			}
		}

		addSlot(input)

		if (tile != null) {
			progress = ProgressGaugeWidget(this, { tile.workProgress.toFloat() }) { tile.cantProcessJob() }
			patterns = LevelGaugeWidget(this,
				{ Fraction(tile.getAsMatterGraph()?.getPatternCount()?.toBigInteger() ?: BigInteger.ZERO) },
				{ Fraction(tile.getAsMatterGraph()?.getPatternCapacity()?.toBigInteger() ?: BigInteger.ZERO) })
		} else {
			progress = ProgressGaugeWidget(this)
			patterns = LevelGaugeWidget(this)
		}

		addBatterySlot()
		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 1
	}
}