package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.Container
import net.minecraft.world.inventory.Slot
import net.minecraft.world.item.ItemStack
import net.minecraftforge.energy.CapabilityEnergy
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.capability.matter.IMatterHandler

open class MatterySlot @JvmOverloads constructor(p_40223_: Container, index: Int, x: Int = 0, y: Int = 0) : Slot(p_40223_, index, x, y)

open class MachineOutputSlot @JvmOverloads constructor(p_40223_: Container, index: Int, x: Int = 0, y: Int = 0) : MatterySlot(p_40223_, index, x, y) {
	override fun mayPlace(p_40231_: ItemStack): Boolean {
		return false
	}
}

open class BatterySlot @JvmOverloads constructor(container: Container, index: Int, x: Int = 0, y: Int = 0) : MatterySlot(container, index, x, y) {
	override fun mayPlace(stack: ItemStack): Boolean {
		val capability = stack.getCapability(CapabilityEnergy.ENERGY)
		return capability.resolve().isPresent && capability.resolve().get().canExtract()
	}
}

open class MatterContainerInputSlot @JvmOverloads constructor(
	p_40223_: Container,
	index: Int,
	x: Int = 0,
	y: Int = 0,
	val direction: IMatterHandler.MatterDirection = IMatterHandler.MatterDirection.BIDIRECTIONAL
) : MatterySlot(p_40223_, index, x, y) {
	override fun mayPlace(p_40231_: ItemStack): Boolean {
		val handler = p_40231_.getCapability(MatteryCapability.MATTER).resolve()
		if (handler.isEmpty) return false
		val direction = handler.get().direction
		return direction == IMatterHandler.MatterDirection.BIDIRECTIONAL || this.direction == direction
	}
}

open class PatternSlot(p_40223_: Container, index: Int, x: Int = 0, y: Int = 0) : MatterySlot(p_40223_, index, x, y) {
	override fun mayPlace(p_40231_: ItemStack): Boolean {
		return p_40231_.getCapability(MatteryCapability.PATTERN).isPresent
	}
}
